Preparing for an interview? Check out Cracking the Coding Interview
Published on

Amazon | SDE-1(Contract) | FTC | Hyderabad | Offer

Author
  • Shared Anonymously

Recruiter from some consultancy contacted me saying that their client amazon had opening for sde-1.

Experience : SDE intern at Amazon(5 months) + Infosys ( Specialist Programmer - 1.5yoe )

Online Assessment :

2 coding questions were given one from hashmap and 2nd was from graphs which is bit hard problem
was able to solve 1st question , but for 2nd question 30% testcases passed i guess

Technical Round I :

1)Interview was taken by sde3 and started with brief introduction and quickly moved on to coding part
2) Coding Question 1 : Given a tree, I have to print all the paths from root to leaf node such that total path sum from root node to leaf node <= m (difficulty : medium)
3) Coding Question 2 : little bit variation to this Question was asked ( https://leetcode.com/problems/course-schedule-ii/description/) (difficulty : medium)
4) 2-3 medium level Behavioural Questions

Technical Round II :
1)Interview was taken by sde2 and interviewer was very cool and gave me ample time to come up with solutions
2)Coding Question 1 : similar to this question was asked ( https://leetcode.com/problems/subarray-sum-equals-k/description/ ) coded and explained within 10 min ( difficulty : easy )
3)Coding Question 2 : The second question was easy but took me a little bit of time as I didn't read the question properly initially and misunderstood it. I first came up with a Priority Queue solution, but after clarifying a few doubts, I realized it wouldn't work. The interviewer gave me a hint to solve it using DP. I considered various DP patterns, but none seemed to fit. After about 25 minutes, I re-read the question and came up with a stack solution. I coded and explained it in the next 10 minutes, and the interviewer seemed satisfied. similar to the following question was asked (taken from gfg)

=> Given a string consisting of lower case alphabets.  
Rules of the Game:   
  
A player can choose a pair of similar consecutive characters and erase them.  
There are two players playing the game, the player who makes the last move wins.  
The task is to find the winner if A goes first and both play optimally.   
Input: str = "kaak"   
Output: B  
Explanation:  
    Initial String: "kaak"  
    A\'s turn:  
        removes: "aa"  
        Remaining String: "kk"  
    B\'s turn:  
        removes: "kk"  
        Remaining String: ""  
    Since B was the last one to play  
    B is the winner.  

Technical & Hiring Manager Round III :

  1. Manager was having 7 yoe and she was very polite and calm.
  2. Coding Question 1: similar to following question was asked ( https://leetcode.com/problems/best-time-to-buy-and-sell-stock-with-transaction-fee/description/ ) told topdown dp approach and she was satisfied with my sol.
  3. She asked everything related to my prev experience from my resume. Questions like

=> frontend optimizations techniques (what is LazyLoading, Code Spliting,Caching)
=> difference between unit,integretion, end-to-end tests ( i was asked this questions because i had work exp in this areas, you dont have to worry about it, just be perfect with things you had written in resume )
=> asked me some questions on amazon internal tools because i had experience in working with them during my internship and a lot of tough behavioral questions was asked. I recommend reviewing previously asked behavioral questions before interviewing at Amazon.

Note : all questions were amazon story based .

Final Verdict: Next Day recruiter called me and told i was selected!

=> I solved around 600 lp and i think neetcode 150, blind75 would be sufficient for preparation of interview, i myself prepared from that list.

=>I had to quit my previous job at Infosys due to personal reasons in feb 2024. I applied for various positions over the past 1.5 months, but I was suprised that not even one company shortlisting my resume (possibly due to less openings on MERN stack and heavy competition). After applying to hundreds of jobs on Naukri and LinkedIn, I got 3 opportunities. I was rejected from 2 startups , this was the 3rd one. I accepted this offer because the recruiter gave me just 1 day to decide. The position was for an immediate joiner, and one of the downside is that, it is through a consultancy, so my payroll will be on that company name.

=>As this is contract job there was no bonus, stocks and only base was given.Though I'm happy to have a job, but on other side it's a contract position for about 8 months which makes me feel disappointed. They said there might be a PPO based on my performance, but I don't have any hopes. i would greatly appreciate if you have any advice for me. Thanks for reading!

ReportMark as Helpful